/* Generated by wayland-scanner 1.14.0 */

#ifndef OUTPUTMANAGEMENT_SERVER_PROTOCOL_H
#define OUTPUTMANAGEMENT_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_outputmanagement The outputmanagement protocol
 * @section page_ifaces_outputmanagement Interfaces
 * - @subpage page_iface_org_kde_kwin_outputmanagement - list connected, but disabled outputs
 * - @subpage page_iface_org_kde_kwin_outputconfiguration - list connected, but disabled outputs
 * @section page_copyright_outputmanagement Copyright
 * <pre>
 *
 * Copyright © 2015 Sebastian Kügler <sebas@kde.org>
 * Copyright © 2008-2011 Kristian Høgsberg
 * Copyright © 2010-2011 Intel Corporation
 * Copyright © 2012-2013 Collabora, Ltd.
 *
 * Permission to use, copy, modify, distribute, and sell this
 * software and its documentation for any purpose is hereby granted
 * without fee, provided that the above copyright notice appear in
 * all copies and that both that copyright notice and this permission
 * notice appear in supporting documentation, and that the name of
 * the copyright holders not be used in advertising or publicity
 * pertaining to distribution of the software without specific,
 * written prior permission.  The copyright holders make no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF
 * THIS SOFTWARE.
 * </pre>
 */
struct org_kde_kwin_outputconfiguration;
struct org_kde_kwin_outputdevice;
struct org_kde_kwin_outputmanagement;

/**
 * @page page_iface_org_kde_kwin_outputmanagement org_kde_kwin_outputmanagement
 * @section page_iface_org_kde_kwin_outputmanagement_desc Description
 *
 * This interface allows to connected output devices for screen configuration purposes.
 *
 * OutputManagement (wl_global)
 * --------------------------
 * request:
 * * createConfiguration -> OutputConfiguration (wl_resource)
 *
 * OutputConfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output, bool)
 * * mode(output, mode_id)
 * * transformation(output, flag)
 * * position(output, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The idea is that we register one OutputManagement as a global. When KScreen
 * wants to configure it calls createConfiguration which provides a resource
 * referencing an OutputConfiguration for one-time configuration. That way we can
 * easily group all requests and know on the server which one belong together. On
 * the OutputConfiguration it calls for each Output whether it's enabled, which
 * mode to use (by referencing the mode from the list of announced modes) and the
 * global position. Once all outputs are configured that way, it calls apply.  At
 * that point and not earlier the server emits a signal to KWin with the complete
 * wanted configuration which KWin can then try to apply. If that succeeds it
 * emits the applied signal, otherwise the failed. So even KScreen can know about
 * it.
 *
 * That interface is nicely atomic (as KWin only gets the apply for everything
 * setup), it solves the 1:n mapping problem: each OutputConfiguration is only a
 * 1:1 mapping, and we do not need to copy all the requests again by just
 * referencing a mode id.
 *
 *
 * @section page_iface_org_kde_kwin_outputmanagement_api API
 * See @ref iface_org_kde_kwin_outputmanagement.
 */
/**
 * @defgroup iface_org_kde_kwin_outputmanagement The org_kde_kwin_outputmanagement interface
 *
 * This interface allows to connected output devices for screen configuration purposes.
 *
 * OutputManagement (wl_global)
 * --------------------------
 * request:
 * * createConfiguration -> OutputConfiguration (wl_resource)
 *
 * OutputConfiguration (wl_resource)
 * --------------------------
 * requests:
 * * enable(output, bool)
 * * mode(output, mode_id)
 * * transformation(output, flag)
 * * position(output, x, y)
 * * apply
 *
 * events:
 * * applied
 * * failed
 *
 * The idea is that we register one OutputManagement as a global. When KScreen
 * wants to configure it calls createConfiguration which provides a resource
 * referencing an OutputConfiguration for one-time configuration. That way we can
 * easily group all requests and know on the server which one belong together. On
 * the OutputConfiguration it calls for each Output whether it's enabled, which
 * mode to use (by referencing the mode from the list of announced modes) and the
 * global position. Once all outputs are configured that way, it calls apply.  At
 * that point and not earlier the server emits a signal to KWin with the complete
 * wanted configuration which KWin can then try to apply. If that succeeds it
 * emits the applied signal, otherwise the failed. So even KScreen can know about
 * it.
 *
 * That interface is nicely atomic (as KWin only gets the apply for everything
 * setup), it solves the 1:n mapping problem: each OutputConfiguration is only a
 * 1:1 mapping, and we do not need to copy all the requests again by just
 * referencing a mode id.
 *
 *
 */
extern const struct wl_interface org_kde_kwin_outputmanagement_interface;
/**
 * @page page_iface_org_kde_kwin_outputconfiguration org_kde_kwin_outputconfiguration
 * @section page_iface_org_kde_kwin_outputconfiguration_desc Description
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the compositor to apply changes to the outputdevices, the monitors connected
 * to the system.
 * The client receives a list of outputdevices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the compositor to apply these settings
 * in an atomic fashion, for example through Linux's DRM interface.
 * The compositor signals back whether the new settings have applied successfully
 * or failed to apply. outputdevices are updated after the hardware changes have
 * been applied and before the server side fires applied.
 * @section page_iface_org_kde_kwin_outputconfiguration_api API
 * See @ref iface_org_kde_kwin_outputconfiguration.
 */
/**
 * @defgroup iface_org_kde_kwin_outputconfiguration The org_kde_kwin_outputconfiguration interface
 *
 * outputconfiguration is a client-specific resource that can be used to ask
 * the compositor to apply changes to the outputdevices, the monitors connected
 * to the system.
 * The client receives a list of outputdevices from the registry. When it wants
 * to apply new settings, it creates a configuration object from the
 * outputmanagement global, writes changes through this object's enable, scale,
 * transform and mode calls. It then asks the compositor to apply these settings
 * in an atomic fashion, for example through Linux's DRM interface.
 * The compositor signals back whether the new settings have applied successfully
 * or failed to apply. outputdevices are updated after the hardware changes have
 * been applied and before the server side fires applied.
 */
extern const struct wl_interface org_kde_kwin_outputconfiguration_interface;

/**
 * @ingroup iface_org_kde_kwin_outputmanagement
 * @struct org_kde_kwin_outputmanagement_interface
 */
struct org_kde_kwin_outputmanagement_interface {
	/**
	 * change the shell surface position
	 *
	 * Request an output configuration, which can be changed and then
	 * applied.
	 */
	void (*create_configuration)(struct wl_client *client,
				     struct wl_resource *resource,
				     uint32_t id);
};


/**
 * @ingroup iface_org_kde_kwin_outputmanagement
 */
#define ORG_KDE_KWIN_OUTPUTMANAGEMENT_CREATE_CONFIGURATION_SINCE_VERSION 1

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 * @struct org_kde_kwin_outputconfiguration_interface
 */
struct org_kde_kwin_outputconfiguration_interface {
	/**
	 * enable or disable an output
	 *
	 * Mark the output as enabled or disabled.
	 * @param enable request to enable or disable this output
	 */
	void (*enable)(struct wl_client *client,
		       struct wl_resource *resource,
		       struct wl_resource *outputdevice,
		       int32_t enable);
	/**
	 * Switch outputdevice to mode
	 *
	 * Sets the mode for a given output by its mode size (width and
	 * height) and refresh rate.
	 * @param outputdevice outputdevice this mode change applies to
	 * @param mode_id aspired mode's id
	 */
	void (*mode)(struct wl_client *client,
		     struct wl_resource *resource,
		     struct wl_resource *outputdevice,
		     int32_t mode_id);
	/**
	 * Transform outputdevice
	 *
	 * Sets the transformation for a given output.
	 * @param outputdevice outputdevice this transformation change applies to
	 * @param transform transform enum
	 */
	void (*transform)(struct wl_client *client,
			  struct wl_resource *resource,
			  struct wl_resource *outputdevice,
			  int32_t transform);
	/**
	 * Position output relative to global
	 *
	 * Sets the position for this output device in the global space.
	 * position describes the top-left border of the output in the
	 * global space. The left-most output's top-left border is 0, 0.
	 * There may be no gaps between outputs, the outputs have to be
	 * positioned stacked horizontally, vertically, or both.
	 * @param outputdevice outputdevice this position applies to
	 * @param x position on the x-axis
	 * @param y position on the y-axis
	 */
	void (*position)(struct wl_client *client,
			 struct wl_resource *resource,
			 struct wl_resource *outputdevice,
			 int32_t x,
			 int32_t y);
	/**
	 * Set the scaling factor for this outputdevice
	 *
	 * Sets the scaling factor for this outputdevice.
	 * @param outputdevice outputdevice this mode change applies to
	 * @param scale scaling factor
	 */
	void (*scale)(struct wl_client *client,
		      struct wl_resource *resource,
		      struct wl_resource *outputdevice,
		      int32_t scale);
	/**
	 * apply the changes to the outputdevices
	 *
	 * Asks the compositor to apply changes to the outputdevices on
	 * the server side.
	 */
	void (*apply)(struct wl_client *client,
		      struct wl_resource *resource);
};

#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLIED 0
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_FAILED 1

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLIED_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_FAILED_SINCE_VERSION 1

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_ENABLE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_TRANSFORM_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_POSITION_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_SCALE_SINCE_VERSION 1
/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 */
#define ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLY_SINCE_VERSION 1

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 * Sends an applied event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
org_kde_kwin_outputconfiguration_send_applied(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ORG_KDE_KWIN_OUTPUTCONFIGURATION_APPLIED);
}

/**
 * @ingroup iface_org_kde_kwin_outputconfiguration
 * Sends an failed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
org_kde_kwin_outputconfiguration_send_failed(struct wl_resource *resource_)
{
	wl_resource_post_event(resource_, ORG_KDE_KWIN_OUTPUTCONFIGURATION_FAILED);
}

#ifdef  __cplusplus
}
#endif

#endif
